
function CollapsibleWrapper({wrapper, options}) {
  let $ctaEl = wrapper.querySelector(options?.clickableSelector || '.collapse-cta')
  let $contentEl = wrapper.querySelector(options?.contentSelector || '.collapse-content');
  let $arrow = wrapper.querySelector('.collapsible-icon');
  let $initialText = wrapper.querySelector(`${options?.textSelector}-text.initial`);
  let $secondaryText = wrapper.querySelector(`${options?.textSelector}-text.secondary`);
  let shouldSwapTexts = !!wrapper.querySelector(`${options?.textSelector}-text`); 

  const toggleCollapsible = () => {
    if($contentEl.style.display === 'none' ) {
      $contentEl.style.display = 'block';
      arrowHandler(true, $arrow);
      textHandler(shouldSwapTexts, true);
    } else {
      $contentEl.style.display = 'none';
      arrowHandler(false, $arrow);
      textHandler(shouldSwapTexts, false);
    }
  }

  const textHandler = (shouldSwap, visible) => {
    if(shouldSwap && visible) {
      $initialText.style.display = 'inline';
      $secondaryText.style.display = 'none';
    }
    if(shouldSwap && !visible) {
      $initialText.style.display = 'none';
      $secondaryText.style.display = 'inline';
    }
  };

  const arrowHandler = (visible, arrow) => {
    console.log(visible, arrow)
    visible ? arrow?.classList.replace('tykon-arrowup', 'tykon-arrowdown') : arrow?.classList.replace('tykon-arrowdown', 'tykon-arrowup');
  }

  const collapsibleEvents = () => {
    $ctaEl?.addEventListener('click', toggleCollapsible);
  };

  collapsibleEvents();
}

export function Collapsible (options) {
  let collapsibleWrappers = document.querySelectorAll(options?.collapsibleWrapper);

  const init = () => {
    collapsibleWrappers.forEach(el => {
      CollapsibleWrapper({wrapper: el, options})
    });
  };

  init();
};

